#region usings
using System;
using System.ComponentModel.Composition;
using System.Collections.Generic;
using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "Boids_Keep_Away", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValueBoids_Keep_AwayNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultValue = 1.0)]
		ISpread<Vector3D> FInput;
		
		[Input("Max Radius", DefaultValue = .001)]
		ISpread<double> FMaxRadius;
		
		[Output("Output")]
		ISpread<Vector3D> FOutput;
		
List<Vector3D> pv = new List<Vector3D>();
		
		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			pv.Clear();
			FOutput.SliceCount = SpreadMax;

			for (int i = 0; i < SpreadMax; i++) {
				
			pv.Add(FInput[i]); //add vecotor to the list
				
					for (int j = 0; j < SpreadMax; j++) {
				
						if (i != j) {
						//then	
						if ( VMath.Dist(pv[i],pv[j])<FMaxRadius[0] )									
						//then	
						pv[i]= 0-(pv[i]-pv[j]);
									}
					
														}	
				
												}

	
		FOutput.AssignFrom(pv);	


			//FLogger.Log(LogType.Debug, "hi tty!");
		}
	}
}
