#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "Boids_Move_to_centre", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValueBoids_Move_to_centreNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultValue = 1.0)]
		ISpread<Vector3D> FInput;

		[Output("Output")]
		ISpread<Vector3D> FOutput;


		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
	
			FOutput.SliceCount = SpreadMax;

			
			Vector3D c = new Vector3D(0,0,0);
			Vector3D pos = new Vector3D(0,0,0);		
			
				for (int j = 0; j < SpreadMax; j++ )
				{
				c+= FInput[j];
				}

			c=c/SpreadMax; //Pcj our flock centre
			
			for (int i = 0; i < SpreadMax; i++ )
			{
			FOutput[i] = (c - FInput[i])/100 ;
			}
			
				

			//FLogger.Log(LogType.Debug, "hi tty!");
		}
	}
}
